#include "local.h"
#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <string.h>
#include "son.h"
#include "em.typ"


/* KRS char *strcpy(),*strcat(); */

fmtr(str,len,val)  int len;  char *str;  Rtyp val;
/*************************************************************/
/* Convert val to ascii restricted to len-1 characters.      */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr27jul87 */ 
{ int fmt_result;

  if (len <= 1) return(-1);

  /*Try formating it regular floating point, if n.g., use sci*/
  fmt_result = fmt_mant(str,len,val);

  /*Check for result too big, if so try sci*/
  if ( fmt_result < 0 ) return( fmte(str,len,val) );

  /*Check for loss of precision, if so try sci*/
  if ( len>6 && fmt_result > 0 ) return( fmte(str,len,val) );

  return(fmt_result);
} /*fmtr*/

static char *trial = NULL;
static int trial_len = 0;

fmte(str,len,val)  int len;  char *str;  Rtyp val;
/*************************************************************/
/* Convert val to ascii sci notation, len-1 characters.      */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr27jul87 */ 
{ char fmt[20];
  int i,j,tlen;

  if (len <= 1)
  { if (len==1) *str = '\0';
    return(-1);
  }
  len--;  /*this makes len the number of characters*/

  /*Make sure enough space is allocated for the trial string*/
  if (trial != NULL && trial_len < len+10)
  { sFree(trial);
    trial = NULL;
    trial_len = 0;
  }
  if (trial==NULL)
  { trial = cnew( len+10,sizeof(char) );
    trial_len = len + 10;
  }

  if ( fabs(val) <= TINY ) /*set to 0.0000 */
  { for (i=0; i<len; i++) *(str+i) = '0';
    *(str+len) = '\0';
    *(str+len-1) = '0';
    if (len== 2) *(str) = ' ';
    if (len>3) *(str+1) = '.';
    return(0);
  }

  /*Make sure str is long enough for shortest poss number*/
  if (len<3)
  { stars(str,len+1);  return(-1); }

  /*Do a trial conversion*/
  sprintf(fmt,"%s%dle","%",len);
  sprintf(trial,fmt,val);
  tlen = strlen(trial);

  /*Change leading zeros in exponent to spaces*/
  i = tlen - 2;
  while ( *(trial+i) != 'e' && *(trial+i) != 'E' && i > 0 ) i--;
  while ( i < tlen-1 ) /*no need to ck units digit of exponent*/
  { if ( *(trial+i) == '0' || *(trial+i) == '+')
      *(trial+i) = ' ';
    else if ( isdigit( *(trial+i) ) )
      i = tlen;
    i++;
  }

  /*Fill up the exponent, skip spaces*/
  *(str+len) = '\0';
  i = tlen - 1;
  j = len - 1;
  while( *(trial+i) != 'e' && *(trial+i) != 'E' && i > 0 && j > 0 )
  { if ( *(trial+i) != ' ' )
    { *(str+j) = *(trial+i);  j--; }
    i--;
  }

  if ( *(trial+i) == 'e' || *(trial+i) == 'E' )
  { *(str+j) = 'e';
    j--;
  }
  else /*No 'e' or 'E' found, something wrong*/
  { stars(str,len+1);  return(-1); }
  
  /*Check to make sure we have enough room left for min length mantissa*/
  if ( ( val >= 0.0 && i < 0 ) || (val < 0.0 && i < 1) )
  { stars(str,len+1);  return(-1); }

  /*Now do the mantissa, lsd to msd*/
  for ( ; j>=0; j-- )
    *(str+j) = *(trial+j);

  return(0);
} /*fmte*/
  
fmt_mant(str,len,val)  int len;  char *str;  Rtyp val;
/*************************************************************/
/* Convert val to ascii restricted to len-1 characters.      */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr27jul87 */ 
/* if result OK, return 0, if n.g., -1, if big loss of prec., 1*/
{ int i,a;  char fmt[20];
  int num_zeros;

  if (len <= 1)
  { if (len==1) *str = '\0';
    return(-1);
  }
  len--;  /*this makes len the number of characters*/

  /*Make sure enough space is allocated for the trial string*/
  if (trial != NULL && trial_len < len+5)
  { sFree(trial);
    trial = NULL;
    trial_len = 0;
  }
  if (trial==NULL)
  { trial = cnew( len+5,sizeof(char) );
    trial_len = len + 5;
  }

  if ( fabs(val) <= TINY ) /*set to 0.0000 */
  { for (i=0; i<len; i++) *(str+i) = '0';
    *(str+len) = '\0';
    *(str+len-1) = '0';
    if (len== 2) *(str) = ' ';
    if (len>3) *(str+1) = '.';
    return(0);
  }

  /*Calculate the number of zero's if only one significant digit in val*/
  num_zeros = log10(fabs(val));  /*Fractional part truncated*/

  if ( val>=0.0 && num_zeros>=len) /*Too big of a pos. number*/
  { stars(str,len+1);  return(-1); }

  if ( val<0.0 && num_zeros>=len-1) /*Too big of a neg. number*/
  { stars(str,len+1);  return(-1); }

  /*Do the formating*/
  a = (fabs(val)<1.0) ? 1 : 2 + num_zeros;
  if (val<0.0) a++;
  if (a>len+3) { stars(str,len+1);  return(-1); }
  if (a>=len) a=len-1;

  /*first try*/
  get_fmt_str(fmt,len,len-a);
  sprintf(trial,fmt,val);
  if (strlen(trial)<=len)
  { strcpy(str,trial);
    /*Check for loss of precision*/
    if ( 5-num_zeros > len ) return(1);
    return(0);
  }

  /*second try*/
  get_fmt_str(fmt,len,len-a-1);
  sprintf(trial,fmt,val);
  if (strlen(trial)<=len)
  { strcpy(str,trial);
    /*Check for loss of precision*/
    if ( 5-num_zeros > len ) return(1);
    return(0);
  }

  /*if just decimal point at end, delete it and return*/
  if ( (strlen(trial)==len+1) && ( !isdigit(*(trial+len)) ) )
  { *(trial+len)='\0';
    strcpy(str,trial);
    /*Check for loss of precision*/
    if ( 5-num_zeros > len ) return(1);
    return(0);
  }

  /*too big*/
  { stars(str,len+1);  return(-1); }

} /*fmt_mant*/

get_fmt_str(fmt,len,dec)  char *fmt;  int len,dec;
/*************************************************************/
/* Generate a format string of the form "%len.decf".         */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr27jul87 */ 
{ char numstr[20];
  strcpy(fmt,"%");  sprintf(numstr,"%d",len);
  strcat(fmt,numstr);  strcat(fmt,".");  sprintf(numstr,"%d",dec);
  strcat(fmt,numstr);  strcat(fmt,"f");
} /*get_fmt_str*/

stars(str,len)  char *str;  int len;
/*************************************************************/
/* Fill str up with starts.                                  */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr27jul87 */ 
{ int i;
  if (len<=0) return(-1);
  for (i=1; i<len; i++,str++) *str='*';
  *str = '\0';
  return(0);
} /*stars*/

fmti(str,len,ival)  char *str;  int len,ival;
/*************************************************************/
/* Convert the integer ival to ascii string of < len-1 char. */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr27jul87 */ 
{ char *trial,fmt[20],nstr[18];
  len--;  /*change to number of characters*/
  trial = new( len+20 );
  strcpy(fmt,"%");  
  sprintf(nstr,"%d",len);  strcat(fmt,nstr);
  strcat(fmt,"d");
  sprintf(trial,fmt,ival);
  if (strlen(trial)>len) { stars(str,len+1);  sFree(trial);  return(-1); }
  strcpy(str,trial);
  sFree(trial);  return(0);
} /*fmti*/
